; ======================================================
;ض
 ORG     0000H
   LJMP    SYSTEM_INIT       ; λתʼ
ORG     000BH
   LJMP    TIMER0_HANDLER    ; ʱ0ж

; ******************** Ӳ˿ڶ **********************

MOTOR_CTRL_PORT   EQU     P2      ; ƶ˿P2.0-P2.3
LED_DISPLAY       EQU     P0      ; ¥ʾ˿P0ڣ
KEY_INPUT         EQU     P1      ; ˿P1ڣЧ?
MOTOR_ENABLE_PIN  EQU     P2.4    ; ʹܿƽP2.4Ч

; ******************** ϵͳ **********************

TOTAL_FLOORS      EQU     8       ; ¥
STEPS_PER_ROT     EQU     200     ; ÿת貽
ROTS_PER_FLOOR    EQU     20      ; ÿӦת
TIMER_INTERVAL    EQU     00FA9AH ; ʱֵԼ1.5ms
STEP_INTERVAL     EQU     4       ; 


; ********************  ***********************

CUR_FLOOR_NUM     DATA    30H     ; ǰ¥㣨1-8
DEST_FLOOR        DATA    31H     ; Ŀ¥㣨0ʾĿ꣩
MOTOR_PHASE_IDX   DATA    32H     ; λ0-7
ROT_COUNTER       DATA    33H     ; תȦ
MOVE_DIRECTION    DATA    34H     ; з־
STEP_DELAY_CNT    DATA    35H     ; ʱ

; ******************** λ ***********************

ORG     100H
PHASE_DRIVE_TABLE:
        DB      00000001B         ; Phase 1: Aͨ
        DB      00000011B         ; Phase 2: A+Bͨ
        DB      00000010B         ; Phase 3: Bͨ 
        DB      00000110B         ; Phase 4: B+Cͨ
        DB      00000100B         ; Phase 5: Cͨ
        DB      00001100B         ; Phase 6: C+Dͨ
        DB      00001000B         ; Phase 7: Dͨ
        DB      00001001B         ; Phase 8: D+Aͨ

; ==================== ϵͳʼ ======================

SYSTEM_INIT:
        MOV     SP, #60H          ; ʼջָ
        MOV     TMOD, #01H        ; T0Ϊģʽ1
        
        ; öʱʼֵ
        MOV     TH0, #HIGH(TIMER_INTERVAL)
        MOV     TL0, #LOW(TIMER_INTERVAL)
        
        ; ж
        SETB    ET0              ; T0ж
        SETB    EA               ; ж
        
        ; ʼϵͳ
        MOV     CUR_FLOOR_NUM, #1 ; ʼ¥Ϊ1
        MOV     LED_DISPLAY, #01H ; LEDʾ1
        MOV     MOTOR_PHASE_IDX, #0
        MOV     ROT_COUNTER, #0
        MOV     MOVE_DIRECTION, #0
        SETB    MOTOR_ENABLE_PIN  ; رյ	

; ==================== ѭ ========================

MAIN_LOOP:
        ACALL   SCAN_KEYPAD       ; ɨ谴
        ACALL   DETERMINE_DIR     ; ȷз
        SJMP    MAIN_LOOP         ; ѭ

; =============== ʱ0жϷ =================

TIMER0_HANDLER:
        PUSH    ACC
        PUSH    PSW
        ; װضʱ
        MOV     TH0, #HIGH(TIMER_INTERVAL)
        MOV     TL0, #LOW(TIMER_INTERVAL)
        
        ; ״̬
        MOV     A, MOVE_DIRECTION
        JZ      TIMER_EXIT        ; ֹͣ״ֱ̬˳
        
        ; ʱ
        INC     STEP_DELAY_CNT
        MOV     A, STEP_DELAY_CNT
        CJNE    A, #STEP_INTERVAL, TIMER_EXIT
        MOV     STEP_DELAY_CNT, #0
        
        ; 
        CLR     MOTOR_ENABLE_PIN  ; ʹܵ
        MOV     A, MOTOR_PHASE_IDX
        MOV     DPTR, #PHASE_DRIVE_TABLE
        MOVC    A, @A+DPTR
        ANL     A, #0FH           ; λ
        MOV     MOTOR_CTRL_PORT, A
        
        ; λأ
        MOV     A, MOVE_DIRECTION
        CJNE    A, #1, HANDLE_DOWN_DIR
        
; з
HANDLE_UP_DIR:                   
        DEC     MOTOR_PHASE_IDX
        SJMP    PHASE_ADJUST
        
; з
HANDLE_DOWN_DIR:                 
        INC     MOTOR_PHASE_IDX
        
; ¥ʾ
PHASE_ADJUST:
        ANL     MOTOR_PHASE_IDX, #07H  ; 0-7Χ
        
        ; Ȧͳ¥
        MOV     A, MOTOR_PHASE_IDX
        JNZ     TIMER_EXIT        ; δ˳
        INC     ROT_COUNTER       ; Ȧ
        MOV     A, ROT_COUNTER
        CJNE    A, #ROTS_PER_FLOOR, TIMER_EXIT
        MOV     ROT_COUNTER, #0   ; Ȧ
        ACALL   UPDATE_FLOOR_DISPLAY ; ¥ʾ

;ж
TIMER_EXIT:
        POP     PSW
        POP     ACC
        RETI

; ================== ɨ ====================
;ɨ谴
SCAN_KEYPAD:
        MOV     A, KEY_INPUT      ; ȡ״̬
        CPL     A                ; ȡ
        JZ      NO_KEY_PRESS      ; ް˳
        
        ; ʱ
        MOV     R5, #40

;ʱ
DELAY_20MS:
        DJNZ    R5, DELAY_20MS
        
        ; μⰴ
        MOV     A, KEY_INPUT
        CPL     A
        JZ      NO_KEY_PRESS
        
        ; 8
        MOV     R6, #8
        MOV     R7, #0


KEY_SCAN_LOOP:
        RRC     A                ; Ƽⰴ
        JNC     KEY_DETECTED      ; ⵽ת
        INC     R7               ; ¥+1
        DJNZ    R6, KEY_SCAN_LOOP
        RET

KEY_DETECTED:
        INC     R7               ; תΪ1-8
        MOV     A, R7
        CJNE    A, CUR_FLOOR_NUM, SET_DEST_FLOOR
        RET                     ; ǰ¥

SET_DEST_FLOOR:
        MOV     DEST_FLOOR, A    ; Ŀ¥

NO_KEY_PRESS:
        RET

; ================ ¥ʾ³ ==================

UPDATE_FLOOR_DISPLAY:
        MOV     A, MOVE_DIRECTION
        CJNE    A, #1, CHECK_DOWN_DIR
        
        ; з
        MOV     A, CUR_FLOOR_NUM
        CJNE    A, #TOTAL_FLOORS, FLOOR_UP
        SJMP    UPDATE_COMPLETE
        
FLOOR_UP:
        INC     CUR_FLOOR_NUM    ; ¥
        SJMP    REFRESH_LED
        
CHECK_DOWN_DIR:
        CJNE    A, #2, UPDATE_COMPLETE
        
        ; з
        MOV     A, CUR_FLOOR_NUM
        CJNE    A, #1, FLOOR_DOWN
        SJMP    UPDATE_COMPLETE
        
FLOOR_DOWN:
        DEC     CUR_FLOOR_NUM    ; ¥

REFRESH_LED:
        MOV     A, CUR_FLOOR_NUM
        DEC     A                ; תΪ0-7
        MOV     DPTR, #LED_CODE_TABLE
        MOVC    A, @A+DPTR
        MOV     LED_DISPLAY, A   ; LEDʾ

UPDATE_COMPLETE:
        ; Ŀ¥
        MOV     A, CUR_FLOOR_NUM
        CJNE    A, DEST_FLOOR, EXIT_UPDATE
        CLR     TR0              ; ֹͣʱ
        MOV     MOVE_DIRECTION, #0
        MOV     DEST_FLOOR, #0
        SETB    MOTOR_ENABLE_PIN ; رյ

EXIT_UPDATE:
        RET

; ================ з߳ ==================

DETERMINE_DIR:
        MOV     A, DEST_FLOOR
        JZ      NO_DESTINATION   ; Ŀ˳
        
        ; ȽĿ뵱ǰ¥
        CLR     C
        SUBB    A, CUR_FLOOR_NUM
        JZ      STOP_ELEVATOR    ; ֹͬͣ
        JC      SET_DOWN_DIR     ; Ŀڵǰ
        
SET_UP_DIR:
        MOV     MOVE_DIRECTION, #1
        SETB    TR0             ; ʱ
        RET
        
SET_DOWN_DIR:
        MOV     MOVE_DIRECTION, #2
        SETB    TR0
        RET
        
STOP_ELEVATOR:
        CLR     TR0
        MOV     MOVE_DIRECTION, #0
        MOV     DEST_FLOOR, #0

NO_DESTINATION:
        RET

; ================ LEDʾ ====================
 ORG     200H
LED_CODE_TABLE:
        DB      01H    ; 1ʾ
        DB      02H    ; 2ʾ
        DB      04H    ; 3ʾ 
        DB      08H    ; 4ʾ
        DB      10H    ; 5ʾ
        DB      20H    ; 6ʾ
        DB      40H    ; 7ʾ
        DB      80H    ; 8ʾ

        END